Classes:
Doctrine
Doctrine_Access
Doctrine_Adapter
Doctrine_Adapter_Db2_Exception
Doctrine_Adapter_Exception
Doctrine_Adapter_Statement
Doctrine_AuditLog
Doctrine_AuditLog_Listener
Doctrine_Collection
Doctrine_Collection_Exception
Doctrine_Collection_Iterator
Doctrine_Collection_Iterator_Expandable
Doctrine_Collection_Iterator_Normal
Doctrine_Collection_Iterator_Offset
Doctrine_Collection_Offset
Doctrine_Column
Doctrine_Compiler
Doctrine_Compiler_Exception
Doctrine_Configurable
Doctrine_Connection
Doctrine_Connection_Common
Doctrine_Connection_Db2
Doctrine_Connection_Exception
Doctrine_Connection_Firebird
Doctrine_Connection_Firebird_Exception
Doctrine_Connection_Informix
Doctrine_Connection_Informix_Exception
Doctrine_Connection_Mock
Doctrine_Connection_Module
Doctrine_Connection_Mssql
Doctrine_Connection_Mssql_Exception
Doctrine_Connection_Mysql
Doctrine_Connection_Mysql_Exception
Doctrine_Connection_Oracle
Doctrine_Connection_Oracle_Exception
Doctrine_Connection_Pgsql
Doctrine_Connection_Pgsql_Exception
Doctrine_Connection_Profiler
Doctrine_Connection_Profiler_Exception
Doctrine_Connection_Sqlite
Doctrine_Connection_Sqlite_Exception
Doctrine_Connection_Statement
Doctrine_Connection_UnitOfWork
Doctrine_DataDict
Doctrine_DataDict_Exception
Doctrine_DataDict_Informix
Doctrine_DataType
Doctrine_Db
Doctrine_Event
Doctrine_EventListener
Doctrine_EventListener_Chain
Doctrine_EventListener_Exception
Doctrine_Exception
Doctrine_Export
Doctrine_Export_Exception
Doctrine_Export_Firebird
Doctrine_Export_Frontbase
Doctrine_Export_Mssql
Doctrine_Export_Mysql
Doctrine_Export_Oracle
Doctrine_Export_Pgsql
Doctrine_Export_Reporter
Doctrine_Export_Schema
Doctrine_Export_Schema_Xml
Doctrine_Export_Schema_Yml
Doctrine_Export_Sqlite
Doctrine_Expression
Doctrine_Expression_Driver
Doctrine_Expression_Exception
Doctrine_Expression_Firebird
Doctrine_Expression_Informix
Doctrine_Expression_Mock
Doctrine_Expression_Mssql
Doctrine_Expression_Mysql
Doctrine_Expression_Oracle
Doctrine_Expression_Pgsql
Doctrine_Expression_Sqlite
Doctrine_File
Doctrine_File_Index
Doctrine_Formatter
Doctrine_Hook
Doctrine_Hook_Equal
Doctrine_Hook_Integer
Doctrine_Hook_Parser
Doctrine_Hook_Parser_Complex
Doctrine_Hook_WordLike
Doctrine_Hydrate
Doctrine_Hydrate_Array
Doctrine_Hydrate_Exception
Doctrine_Hydrate_Record
Doctrine_Import
Doctrine_Import_Builder
Doctrine_Import_Builder_BaseClass
Doctrine_Import_Builder_Exception
Doctrine_Import_Exception
Doctrine_Import_Firebird
Doctrine_Import_Informix
Doctrine_Import_Mssql
Doctrine_Import_Mysql
Doctrine_Import_Oracle
Doctrine_Import_Pgsql
Doctrine_Import_Reader
Doctrine_Import_Reader_Db
Doctrine_Import_Reader_Exception
Doctrine_Import_Reader_Xml_Propel
Doctrine_Import_Schema
Doctrine_Import_Schema_Xml
Doctrine_Import_Schema_Yml
Doctrine_Import_Sqlite
Doctrine_IntegrityMapper
Doctrine_Lib
Doctrine_Locking_Exception
Doctrine_Locking_Manager_Pessimistic
Doctrine_Manager
Doctrine_Manager_Exception
Doctrine_Node
Doctrine_Node_AdjacencyList
Doctrine_Node_AdjacencyList_LevelOrderIterator
Doctrine_Node_AdjacencyList_PostOrderIterator
Doctrine_Node_AdjacencyList_PreOrderIterator
Doctrine_Node_Exception
Doctrine_Node_MaterializedPath
Doctrine_Node_MaterializedPath_LevelOrderIterator
Doctrine_Node_MaterializedPath_PostOrderIterator
Doctrine_Node_MaterializedPath_PreOrderIterator
Doctrine_Node_NestedSet
Doctrine_Node_NestedSet_LevelOrderIterator
Doctrine_Node_NestedSet_PostOrderIterator
Doctrine_Node_NestedSet_PreOrderIterator
Doctrine_Null
Doctrine_Object
Doctrine_Plugin
Doctrine_Query
Doctrine_Query_Abstract
Doctrine_Query_Check
Doctrine_Query_Condition
Doctrine_Query_Exception
Doctrine_Query_Filter
Doctrine_Query_Filter_Chain
Doctrine_Query_From
Doctrine_Query_Groupby
Doctrine_Query_Having
Doctrine_Query_JoinCondition
Doctrine_Query_Limit
Doctrine_Query_Offset
Doctrine_Query_Orderby
Doctrine_Query_Parser
Doctrine_Query_Part
Doctrine_Query_Select
Doctrine_Query_Set
Doctrine_Query_Where
Doctrine_RawSql
Doctrine_RawSql_Exception
Doctrine_Record
Doctrine_Record_Abstract
Doctrine_Record_Exception
Doctrine_Record_Filter
Doctrine_Record_Iterator
Doctrine_Record_Listener
Doctrine_Record_Listener_Chain
Doctrine_Record_State_Exception
Doctrine_Relation
Doctrine_Relation_Association
Doctrine_Relation_Association_Self
Doctrine_Relation_Exception
Doctrine_Relation_ForeignKey
Doctrine_Relation_LocalKey
Doctrine_Relation_Nest
Doctrine_Relation_Parser
Doctrine_Relation_Parser_Exception
Doctrine_Schema
Doctrine_Schema_Column
Doctrine_Schema_Database
Doctrine_Schema_Exception
Doctrine_Schema_Object
Doctrine_Schema_Relation
Doctrine_Schema_Table
Doctrine_Search
Doctrine_Search_Analyzer
Doctrine_Search_Analyzer_Exception
Doctrine_Search_Analyzer_Standard
Doctrine_Search_Exception
Doctrine_Search_Indexer
Doctrine_Search_Indexer_Dir
Doctrine_Search_Indexer_Exception
Doctrine_Search_Listener
Doctrine_Search_Parser
Doctrine_Search_Query
Doctrine_Search_Record
Doctrine_Search_Scorer
Doctrine_Search_Template
Doctrine_Sequence
Doctrine_Sequence_Db2
Doctrine_Sequence_Exception
Doctrine_Sequence_Firebird
Doctrine_Sequence_Informix
Doctrine_Sequence_Mssql
Doctrine_Sequence_Mysql
Doctrine_Sequence_Oracle
Doctrine_Sequence_Pgsql
Doctrine_Sequence_Sqlite
Doctrine_Table
Doctrine_Table_Exception
Doctrine_Table_Repository
Doctrine_Table_Repository_Exception
Doctrine_Template
Doctrine_Template_NestedSet
Doctrine_Template_Searchable
Doctrine_Template_Taggable
Doctrine_Template_Versionable
Doctrine_Tokenizer
Doctrine_Transaction
Doctrine_Transaction_Exception
Doctrine_Transaction_Firebird
Doctrine_Transaction_Informix
Doctrine_Transaction_Mock
Doctrine_Transaction_Mssql
Doctrine_Transaction_Mysql
Doctrine_Transaction_Oracle
Doctrine_Transaction_Pgsql
Doctrine_Transaction_Sqlite
Doctrine_Tree
Doctrine_Tree_AdjacencyList
Doctrine_Tree_Exception
Doctrine_Tree_MaterializedPath
Doctrine_Tree_NestedSet
Doctrine_Util
Doctrine_Validator
Doctrine_Validator_Country
Doctrine_Validator_Creditcard
Doctrine_Validator_Date
Doctrine_Validator_Email
Doctrine_Validator_Enum
Doctrine_Validator_ErrorStack
Doctrine_Validator_Exception
Doctrine_Validator_HtmlColor
Doctrine_Validator_Ip
Doctrine_Validator_Minlength
Doctrine_Validator_Nospace
Doctrine_Validator_Notblank
Doctrine_Validator_Notnull
Doctrine_Validator_Range
Doctrine_Validator_Regexp
Doctrine_Validator_Unique
Doctrine_Validator_Unsigned
Doctrine_Validator_Usstate
Doctrine_View
Doctrine_View_Exception
Doctrine_Cache
Doctrine_Cache
Doctrine_Cache_Apc
Doctrine_Cache_Array
Doctrine_Cache_Db
Doctrine_Cache_Driver
Doctrine_Cache_Exception
Doctrine_Cache_Memcache
Doctrine_Adapter
Doctrine_Adapter_Db2
Doctrine_Adapter_Mock
Doctrine_Adapter_Mysqli
Doctrine_Adapter_Oracle
Doctrine_Adapter_Statement_Mock
Doctrine_DataDict
Doctrine_DataDict_Firebird
Doctrine_DataDict_Mssql
Doctrine_DataDict_Mysql
Doctrine_DataDict_Oracle
Doctrine_DataDict_Pgsql
Doctrine_DataDict_Sqlite

# Class: Doctrine_Cache

Source Location: /Doctrine/Cache.php

## Class Doctrine_Cache

Class Overview

Implements interfaces: Countable (internal interface) IteratorAggregate (internal interface) Doctrine_Cache Located in /Doctrine/Cache.php [line 34]
    Doctrine_EventListener
       |
       --Doctrine_Cache
Author(s): Konsta Vesterinen <kvesteri@cc.hut.fi> Information Tags:
Version: | $Revision: 1857 $
Link: | www.phpdoctrine.com
Since: | 1.0
License: | LGPL
| Properties $_data $_driver $_options $_queries $_success | Methods __construct add appendStats clean count getAll getDriver getIterator getOption isSuccessful pop preExecute preFetch preFetchAll preQuery readStats reset setOption

[ Top ]
Inherited Properties, Constants, and Methods

Inherited Properties | Inherited Methods | Inherited Constants
--- | --- | ---
| Inherited From Doctrine_EventListener Doctrine_EventListener::onCollectionDelete() Doctrine_EventListener::onOpen() Doctrine_EventListener::onPreCollectionDelete() Doctrine_EventListener::postClose() Doctrine_EventListener::postConnect() Doctrine_EventListener::postError() Doctrine_EventListener::postExec() Doctrine_EventListener::postFetch() Doctrine_EventListener::postFetchAll() Doctrine_EventListener::postPrepare() Doctrine_EventListener::postQuery() Doctrine_EventListener::postSavepointCommit() Doctrine_EventListener::postSavepointCreate() Doctrine_EventListener::postSavepointRollback() Doctrine_EventListener::postStmtExecute() Doctrine_EventListener::postTransactionBegin() Doctrine_EventListener::postTransactionCommit() Doctrine_EventListener::postTransactionRollback() Doctrine_EventListener::preClose() Doctrine_EventListener::preConnect() Doctrine_EventListener::preError() Doctrine_EventListener::preExec() Doctrine_EventListener::preFetch() Doctrine_EventListener::preFetchAll() Doctrine_EventListener::prePrepare() Doctrine_EventListener::preQuery() Doctrine_EventListener::preSavepointCommit() Doctrine_EventListener::preSavepointCreate() Doctrine_EventListener::preSavepointRollback() Doctrine_EventListener::preStmtExecute() Doctrine_EventListener::preTransactionBegin() Doctrine_EventListener::preTransactionCommit() Doctrine_EventListener::preTransactionRollback() |

[ Top ]
Property Summary

array | $_data |
Doctrine_Cache_Interface | $_driver |
array | $_options |
array | $_queries |
boolean | $_success |

[ Top ]
Method Summary

Doctrine_Cache | __construct() | constructor
void | add() | add adds a query to internal query stack
void | appendStats() | appendStats
boolean | clean() | save
integer | count() | count
array | getAll() | getQueries
Doctrine_Cache_Driver | getDriver() | getDriver returns the current cache driver
ArrayIterator | getIterator() | getIterator
mixed | getOption() | getOption
boolean | isSuccessful() |
string | pop() | pop
boolean | preExecute() | preExecute listens the preExecute event of Doctrine_Connection_Statement
array | preFetch() | preFetch listens the preFetch event of Doctrine_Connection_Statement
array | preFetchAll() | preFetch listens the preFetchAll event of Doctrine_Connection_Statement
boolean | preQuery() | preQuery listens on the Doctrine_Event preQuery event
array | readStats() | readStats
void | reset() | reset
boolean | setOption() | setOption

[ Top ]
Properties
array $_data = array() [line 57]
API Tags:

Access: | protected

[ Top ]
Doctrine_Cache_Interface $_driver [line 53]
API Tags:

Access: | protected

[ Top ]
array $_options = array('size' => 1000,
'lifeTime' => 3600,
'addStatsPropability' => 0.25,
'savePropability' => 0.10,
'cleanPropability' => 0.01,
'statsFile' => '../data/stats.cache',
) [line 39]
API Tags:

Access: | protected

[ Top ]
array $_queries = array() [line 49]
API Tags:

Access: | protected

[ Top ]
boolean $_success = false [line 61]
API Tags:

Access: | protected

[ Top ]
Methods
Constructor __construct [line 68]

`Doctrine_Cache __construct( Doctrine_Cache_Interface|string $driver, [array $options = array()] )`

constructor

Parameters:

Doctrine_Cache_Interface|string | $driver: | cache driver name or a driver object
array | $options: | cache driver options

API Tags:

Access: | public

[ Top ]
add [line 139]

`void add( string|array $query, [string $namespace = null] )`

add adds a query to internal query stack

Parameters:

string|array | $query: | sql query string
string | $namespace: | connection namespace

API Tags:

Access: | public

[ Top ]
appendStats [line 267]

`void appendStats( )`

appendStats

adds all queries to stats file

API Tags:

Access: | public

[ Top ]
clean [line 215]

`boolean clean( )`

save

API Tags:

Access: | public

[ Top ]
count [line 190]

`integer count( )`

count

API Tags:

Return: | the number of queries in the stack
Access: | public

Implementation of:

Countable::count

[ Top ]
getAll [line 153]

`array getAll( [string $namespace = null] )`

getQueries

Parameters:

string | $namespace: | optional query namespace

API Tags:

Return: | an array of sql query strings
Access: | public

[ Top ]
getDriver [line 93]

`Doctrine_Cache_Driver getDriver( )`

getDriver returns the current cache driver

API Tags:

Access: | public

[ Top ]
getIterator [line 199]

`ArrayIterator getIterator( )`

getIterator

API Tags:

Return: | an iterator that iterates through the query stack
Access: | public

Implementation of:

IteratorAggregate::getIterator

[ Top ]
getOption [line 123]

`mixed getOption( mixed $option )`

getOption

Parameters:

mixed | $option: | the option name

API Tags:

Return: | option value
Access: | public

[ Top ]
isSuccessful [line 206]

`boolean isSuccessful( )`

API Tags:

Return: | whether or not the last cache operation was successful
Access: | public

[ Top ]
pop [line 171]

`string pop( )`

pop

pops a query from the stack

API Tags:

Access: | public

[ Top ]
preExecute [line 362]

`boolean preExecute( Doctrine_Event $event )`

preExecute listens the preExecute event of Doctrine_Connection_Statement

adds the issued query to internal query stack and checks if cached element exists

Parameters:

Doctrine_Event | $event: |

API Tags:

Access: | public

[ Top ]
preFetch [line 335]

`array preFetch( Doctrine_Event $event )`

preFetch listens the preFetch event of Doctrine_Connection_Statement

advances the internal pointer of cached data and returns the current element

Parameters:

Doctrine_Event | $event: |

API Tags:

Access: | public

Redefinition of:

Doctrine_EventListener::preFetch()

[ Top ]
preFetchAll [line 349]

`array preFetchAll( Doctrine_Event $event )`

preFetch listens the preFetchAll event of Doctrine_Connection_Statement

returns the current cache data array

Parameters:

Doctrine_Event | $event: |

API Tags:

Access: | public

Redefinition of:

Doctrine_EventListener::preFetchAll()

[ Top ]
preQuery [line 291]

`boolean preQuery( Doctrine_Event $event )`

preQuery listens on the Doctrine_Event preQuery event

adds the issued query to internal query stack and checks if cached element exists

Parameters:

Doctrine_Event | $event: |

API Tags:

Access: | public

Redefinition of:

Doctrine_EventListener::preQuery()

[ Top ]
readStats [line 250]

`array readStats( )`

readStats

API Tags:

Access: | public

[ Top ]
reset [line 181]

`void reset( )`

reset

removes all queries from the query stack

API Tags:

Access: | public

[ Top ]
setOption [line 104]

`boolean setOption( mixed $option, mixed $value )`

setOption

Parameters:

mixed | $option: | the option name
mixed | $value: | option value

API Tags:

Return: | TRUE on success, FALSE on failure
Access: | public

[ Top ]